import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.util.*;
/**
 * JList render de imagenes
 *
 * @author G. Cherencio
 * @version 1.0
 */
public class JListRenderer extends DefaultListCellRenderer {
    private Map<String, ImageIcon> imageMap = null;
    private Font font = new Font("helvitica", Font.BOLD, 24);
    public JListRenderer() {
        this(new HashMap<String,ImageIcon>());
    }
    public JListRenderer(Map<String,ImageIcon> map) {
        imageMap = map;
    }
    
    @Override
    public Component getListCellRendererComponent(JList list, Object value, int index,
            boolean isSelected, boolean cellHasFocus) {
    
        JLabel label = (JLabel) super.getListCellRendererComponent(list, value, index, isSelected, cellHasFocus);
        label.setIcon(imageMap.get((String) value));
        label.setHorizontalTextPosition(JLabel.RIGHT);
        label.setFont(font);
        return label;
    }
}
