import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.event.*;
import java.util.*;
import java.io.*;
import java.net.*;
/**
 * Interfaz grafica
 *
 * @author G. Cherencio
 * @version 1.0
 */
public class Main {
    private JFrame fr = new JFrame("Fork Generator");
    private Proceso fp = new Proceso();
    private DefaultMutableTreeNode dmtn = new DefaultMutableTreeNode(fp);
    private DefaultMutableTreeNode root = dmtn;
    private DefaultTreeModel dtm = new DefaultTreeModel(dmtn);
    private JTree tree = new JTree(dtm);
    private JTextArea code = new JTextArea();
    private JTextArea msg = new JTextArea();
    private JTextField txtHijos = new JTextField("6");
    private JTextField txtNivel = new JTextField("2");
    private JTextField txtGrado = new JTextField("2");
    private JTextField txtExec = new JTextField(8);
    private JScrollPane scrTree = new JScrollPane(tree);
    private JScrollPane scrCode = new JScrollPane(code);
    private JScrollPane scrMsg = new JScrollPane(msg);
    private JSplitPane split = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,scrTree,scrCode);
    private DefaultMutableTreeNode currentNode = null;
    private Set<Proceso> sp = new HashSet<Proceso>();
    private JButton btnGen = new JButton("C");
    private JButton btnEx = new JButton("!");
    private JList<String> lst = new JList<String>(new String[] {"caso1", "caso2", "caso3", "caso4"});
    private JScrollPane scrlst = new JScrollPane(lst);
    private JPanel pSouth = new JPanel();
    private JPanel pSouth1 = new JPanel();
    private JPanel pSouth2 = new JPanel();
    private JLabel lblCaso1 = new JLabel("Use (+) para agregar proceso, (-) para quitar");
    private JLabel lblCaso2 = new JLabel("Indique la cantidad de procesos hijos a generar en abanico");
    private JLabel lblCaso3 = new JLabel("Indique la cantidad de niveles (profundidad) e hijos por nodos");
    private JLabel lblCaso4 = new JLabel("Indique la cantidad de hijos encadenados a generar");
    private JLabel lblcmd = new JLabel("Comando (exec):");
    private String[] tipo = new String[] {"while(1);","wait();","exec();"}; 
    private String[] tipoMsg = new String[] {"Los procesos no finalizan, quedan en loop infinito",
        "Los procesos no generan huerfanos ni zombies, main finaliza ultimo",
        "Indique el nombre del comando por el cual se reemplazaran los procesos"}; 
    private JComboBox<String> cmbTipo = new JComboBox<String>(tipo);
    
    /**
     * Constructor for objects of class Main
     */
    public Main()
    {
        // customize JList
        lst.setCellRenderer(new JListRenderer(createImageMap()));  
        scrlst.setPreferredSize(new Dimension(300, 150));        
        // customize msg textarea
        msg.setEditable(false);
        // customize buttons
        btnGen.setToolTipText("Genera codigo ANSI C");
        btnEx.setToolTipText("Compila, Linkea codigo y ejecuta en Terminal");
        
        // customize JTree
        sp.add(fp);
        tree.setEditable(false);
        tree.getSelectionModel().setSelectionMode(TreeSelectionModel.SINGLE_TREE_SELECTION);
        tree.setShowsRootHandles(true);
        //Create a split pane with the two scroll panes in it.
        split.setOneTouchExpandable(true);
        split.setDividerLocation(150);
        //Provide minimum sizes for the two components in the split pane
        Dimension minimumSize = new Dimension(100, 50);
        scrTree.setMinimumSize(minimumSize);
        scrCode.setMinimumSize(minimumSize);
        //Customize JTextArea
        code.setTabSize(3);
        
        // adds
        pSouth2.setLayout(new GridLayout(1,1));
        pSouth1.add(new JLabel(""));
        pSouth2.add(scrMsg);
        pSouth.setLayout(new GridLayout(2,1));
        pSouth.add(pSouth1);
        pSouth.add(pSouth2);
        fr.add(scrlst,BorderLayout.WEST);
        fr.add(new JLabel("Seleccione el caso fork() a generar"),BorderLayout.NORTH);
        fr.add(split,BorderLayout.CENTER);
        fr.add(pSouth,BorderLayout.SOUTH);

        // handlers
        fr.addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e) {
                System.exit(0);
            }
        });
        cmbTipo.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                if ( cmbTipo.getSelectedIndex() == 2 && (lst.getSelectedIndex() == 2 || lst.getSelectedIndex() == 3) ) {
                    JOptionPane.showMessageDialog(null,"Esta opcion no es valida para este caso! (se asume wait(0))","Forkgen",JOptionPane.INFORMATION_MESSAGE);
                    cmbTipo.setSelectedIndex(1);
                } else {
                    JOptionPane.showMessageDialog(null,tipoMsg[cmbTipo.getSelectedIndex()],"Forkgen",JOptionPane.INFORMATION_MESSAGE);
                }
                if (cmbTipo.getSelectedIndex() == 2) txtExec.requestFocus();
            }
        });
        lst.addListSelectionListener(new ListSelectionListener() {
            public void valueChanged(ListSelectionEvent e) {
                String caso = lst.getSelectedValue();
                if ( caso.equals("caso1") ) {
                    // caso1
                    split.setDividerLocation(150);
                    split.setLeftComponent(scrTree);
                    pSouth1.removeAll();
                    pSouth1.add(lblCaso1);
                    pSouth1.add(btnGen);
                    pSouth1.add(btnEx);
                    pSouth1.add(cmbTipo);
                    pSouth1.add(lblcmd);
                    pSouth1.add(txtExec);
                } else if ( caso.equals("caso2") ) {
                    JPanel pCaso2 = new JPanel();
                    pCaso2.setLayout(new GridLayout(10,2));
                    pCaso2.add(new JLabel("Hijos:"));
                    pCaso2.add(txtHijos);
                    for(int i=0;i<18;i++) pCaso2.add(new JLabel(" "));
                    split.setDividerLocation(200);
                    split.setLeftComponent(pCaso2);
                    pSouth1.removeAll();
                    pSouth1.add(lblCaso2);
                    pSouth1.add(btnGen);
                    pSouth1.add(btnEx);
                    pSouth1.add(cmbTipo);
                    pSouth1.add(lblcmd);
                    pSouth1.add(txtExec);
                } else if ( caso.equals("caso3") ) {
                    JPanel pCaso3 = new JPanel();
                    pCaso3.setLayout(new GridLayout(10,2));
                    pCaso3.add(new JLabel("Nivel:"));
                    pCaso3.add(txtNivel);
                    pCaso3.add(new JLabel("Grado:"));
                    pCaso3.add(txtGrado);
                    for(int i=0;i<16;i++) pCaso3.add(new JLabel(" "));
                    split.setDividerLocation(200);
                    split.setLeftComponent(pCaso3);
                    pSouth1.removeAll();
                    pSouth1.add(lblCaso3);
                    pSouth1.add(btnGen);
                    pSouth1.add(btnEx);
                    pSouth1.add(cmbTipo);
                    pSouth1.add(lblcmd);
                    pSouth1.add(txtExec);
                } else { // caso4
                    JPanel pCaso4 = new JPanel();
                    pCaso4.setLayout(new GridLayout(10,2));
                    pCaso4.add(new JLabel("Hijos:"));
                    pCaso4.add(txtHijos);
                    for(int i=0;i<18;i++) pCaso4.add(new JLabel(" "));
                    split.setDividerLocation(200);
                    split.setLeftComponent(pCaso4);
                    pSouth1.removeAll();
                    pSouth1.add(lblCaso4);
                    pSouth1.add(btnGen);
                    pSouth1.add(btnEx);
                    pSouth1.add(cmbTipo);
                    pSouth1.add(lblcmd);
                    pSouth1.add(txtExec);
                }
                fr.invalidate();
                fr.validate();
            }
        });
        btnGen.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                switch(lst.getSelectedIndex()) {
                    case 0: doCaso1();break;
                    case 1: doCaso2();break;
                    case 2: doCaso3();break;
                    case 3: doCaso4();break;
                }
            }
        });
        btnEx.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent e) {
                String caso = lst.getSelectedValue();
                String fn = caso+".c";
                String fo = caso;
                if ( code.getText().length()>0 ) {
                    try {
                        PrintWriter writer = new PrintWriter(fn, "UTF-8");
                        writer.print(code.getText());
                        writer.close();               
                        Process process = new ProcessBuilder("gcc","-o",fo,fn).start();
                        InputStream is = process.getInputStream();
                        InputStreamReader isr = new InputStreamReader(is);
                        BufferedReader br = new BufferedReader(isr);
                        String line = null;
                        while ((line = br.readLine()) != null) {
                            System.out.println(line);
                        }       
                        br.close();
                        File f = new File(fo);
                        if ( f.exists() && f.canExecute() ) {
                            // lanzo terminal y ejecuto script que ejecuta programa
                            File file = new File("start.sh");
                            FileWriter fw = new FileWriter(file.getAbsoluteFile());
                            BufferedWriter bw = new BufferedWriter(fw);
                            bw.write("#!/bin/bash\n./"+fo+"\nread -p \"Presione Enter para continuar...\"\n");
                            bw.close();
                            fw.close();
                            process = new ProcessBuilder("chmod","+x","start.sh").start();
                            System.out.println("Ejecuto "+file.getCanonicalPath());
                            process = new ProcessBuilder("x-terminal-emulator","-e",file.getCanonicalPath()).start();
                            is = process.getInputStream();
                            isr = new InputStreamReader(is);
                            br = new BufferedReader(isr);
                            line = null;
                            while ((line = br.readLine()) != null) {
                                System.out.println(line);
                            }       
                        } else System.out.println("Error! ["+fo+"] no existe o no se puede ejecutar\n");
                    } catch(IOException ioe) {
                    }
                }
            }
        });
        tree.addTreeSelectionListener(new TreeSelectionListener() {
            public void valueChanged(TreeSelectionEvent e) {
            //Returns the last path element of the selection.
            //This method is useful only when the selection model allows a single selection.
                DefaultMutableTreeNode node = (DefaultMutableTreeNode) tree.getLastSelectedPathComponent();
                currentNode = node;
                //Nothing is selected.     
                if (node == null) return;
            
                Object nodeInfo = node.getUserObject();
                Proceso p = (Proceso) nodeInfo;
                if (node.isLeaf()) {
                    System.out.println("Proceso hoja ["+p.getNombre()+"]");
                } else {
                    System.out.println("Proceso no hoja ["+p.getNombre()+"]");
                }
            }            
        });
        tree.addKeyListener(new KeyListener() {
            public void keyPressed(KeyEvent e) {
                char c=e.getKeyChar();
                switch(c) {
                    case '+':
                        DefaultMutableTreeNode parentNode = null;
                        TreePath parentPath = tree.getSelectionPath();
                        if (parentPath == null) {
                            //There is no selection. Default to the root node.
                            parentNode = root;
                        } else {
                            parentNode = (DefaultMutableTreeNode) (parentPath.getLastPathComponent());
                        }
                        Proceso p = null;
                        do {
                            String pname = JOptionPane.showInputDialog("Nombre de Proceso:");
                            p = new Proceso(pname);
                        } while(sp.contains(p));
                        sp.add(p);
                        DefaultMutableTreeNode childNode = new DefaultMutableTreeNode(p);
                        dtm.insertNodeInto(childNode, parentNode,parentNode.getChildCount());
                        tree.scrollPathToVisible(new TreePath(childNode.getPath()));
                        break;
                    case '-':
System.out.println("(-)");
                        TreePath currentSelection = tree.getSelectionPath();
                        if (currentSelection != null) {
                            DefaultMutableTreeNode currentNode = (DefaultMutableTreeNode)
                                         (currentSelection.getLastPathComponent());
                            MutableTreeNode parent = (MutableTreeNode)(currentNode.getParent());
                            if (parent != null) {
                                dtm.removeNodeFromParent(currentNode);
                                return;
                            }
                        }
                        break;
                }
            }
            public void keyReleased(KeyEvent e) {
            }
            public void keyTyped(KeyEvent e) {
            }
        });

        // initialise instance variables
        lst.setSelectedIndex(0);
        fr.setSize(800,600);
        fr.setLocationRelativeTo(null);
        fr.setExtendedState(JFrame.MAXIMIZED_BOTH); // maximizar ventana
        fr.setVisible(true);
    }

    private Map<String, ImageIcon> createImageMap() {
        Map<String, ImageIcon> map = new HashMap<>();
        try {
            map.put("caso1", new ImageIcon(getClass().getResource("caso1200x150.png")));
            map.put("caso2", new ImageIcon(getClass().getResource("caso2200x150.png")));
            map.put("caso3", new ImageIcon(getClass().getResource("caso3200x150.png")));
            map.put("caso4", new ImageIcon(getClass().getResource("caso4200x150.png")));
        } catch (Exception ex) {
            ex.printStackTrace();
        }
        return map;
    }
    /*********************************************************************************************************************
     * code generation case 1
     *********************************************************************************************************************/
    private void doCaso1() {
        StringBuffer sb = new StringBuffer(Proceso.getHeaderProgram());
        Enumeration<DefaultMutableTreeNode> en = root.preorderEnumeration();
        String caso = lst.getSelectedValue();
        String stipo = tipo[cmbTipo.getSelectedIndex()];
        while(en.hasMoreElements()) {
            DefaultMutableTreeNode n = en.nextElement();
            Proceso p = (Proceso) n.getUserObject();
            StringBuffer sm = new StringBuffer(); // buffer de generacion de codigo temporario
            String tabs = Util.getTreeTabs(n);
            int level = Util.getNumOfParents(n);
            // agrego el codigo para los procesos hijos de este proceso
            for(int i=0;i < n.getChildCount();i++) {
                sm.append(Util.repeatChar('\t',level+i+1)+"pid = fork();\n");
                sm.append(Util.repeatChar('\t',level+i+1)+"if (pid == 0) {\n");
                Proceso ph = (Proceso) ((DefaultMutableTreeNode) n.getChildAt(i)).getUserObject();
                sm.append(Util.repeatChar('\t',level+i+1)+"\t// "+ph.getNombre()+"\n");
                //sm.append(Util.repeatChar('\t',level+i+1)+"\t@"+ph.getNombre()+"\n");
                sm.append("@"+ph.getNombre()+"\n"); // idea: guardar aqui la cantidad de tabs a agregar cuando se reemplaza el codigo
                sm.append(Util.repeatChar('\t',level+i+1)+"} else {\n");
                if ( stipo.equals(tipo[1]) ) { // wait();
                    sm.append(Util.repeatChar('\t',level+i+2)+"wait(0);\n");
                }
            }
            // agrego el codigo del proceso actual
            sm.append(Util.repeatChar('\t',level+n.getChildCount()+1)+"// "+p.getNombre()+"\n");
            sm.append(p.getCode(Util.repeatChar('\t',level+n.getChildCount()+1)));
            if ( stipo.equals(tipo[0]) ) { // while(1);
                sm.append(Util.repeatChar('\t',level+n.getChildCount()+1)+tipo[0]+"\n");
            } else if ( stipo.equals(tipo[2]) ) { // exec()
                String cmd = "\""+txtExec.getText().trim()+"\"";
                sm.append(Util.repeatChar('\t',level+n.getChildCount()+1)+"execlp("+cmd+","+cmd+",0);\n");
            }
            // cierro los if's que quedaron abiertos
            for(int i=n.getChildCount()-1;i>=0;i--) {
                Proceso ph = (Proceso) ((DefaultMutableTreeNode) n.getChildAt(i)).getUserObject();
                sm.append(Util.repeatChar('\t',level+i+1)+"} //"+ph.getNombre()+"\n");
            }
            // reemplazo el codigo de este proceso en el buffer principal
            int idx = sb.indexOf("@"+p.getNombre());
            sb.replace(idx,idx+p.getNombre().length()+1,sm.toString());
            System.out.println(p);
        }
        code.setText(sb.toString());
    }
    /*********************************************************************************************************************
     * code generation case 2
     *********************************************************************************************************************/
    private void doCaso2() {
        StringBuffer sb = new StringBuffer(Proceso.getHeaderProgram());
        String caso = lst.getSelectedValue();
        String stipo = tipo[cmbTipo.getSelectedIndex()];
        StringBuffer sm = new StringBuffer(); // buffer de generacion de codigo temporario
        sm.append("\tint i;\n");
        sm.append("\tfor(i=0;i<"+txtHijos.getText().trim()+";i++) {\n");
        sm.append("\t\tpid = fork();\n");
        sm.append("\t\tif ( pid == 0) break;\n");
        sm.append("\t}\n");
        if ( stipo.equals(tipo[0]) ) { // while(1);
            sm.append("\tprintf(\"pid=%d ppid=%d\\n\",getpid(),getppid());\n");
            sm.append("\t"+tipo[0]+"\n");
        } else if ( stipo.equals(tipo[1]) ) { // wait(0)
            sm.append("\tif ( pid > 0 ) for(i=0;i<"+txtHijos.getText().trim()+";i++) wait(0);\n");
            sm.append("\tprintf(\"pid=%d ppid=%d\\n\",getpid(),getppid());\n");
        } else { // exec()
            String cmd = "\""+txtExec.getText().trim()+"\"";
            sm.append("\tif ( pid == 0 ) execlp("+cmd+","+cmd+",0);\n");
            sm.append("\tprintf(\"pid=%d ppid=%d\\n\",getpid(),getppid());\n");
        }
        // reemplazo el codigo de este proceso en el buffer principal
        int idx = sb.indexOf("@main");
        sb.replace(idx,idx+5,sm.toString());
        code.setText(sb.toString());
    }
    /*********************************************************************************************************************
     * code generation case 3
     *********************************************************************************************************************/
    private void doCaso3() {
        StringBuffer sb = new StringBuffer(Proceso.getHeaderProgram());
        String caso = lst.getSelectedValue();
        String stipo = tipo[cmbTipo.getSelectedIndex()];
        StringBuffer sm = new StringBuffer(); // buffer de generacion de codigo temporario
        java.util.List<String> lst = new ArrayList<String>(); // buffer de generacion de codigo temporario2
        sm.append("\tint i;\n");
        sm.append("\tfor(i=0;i<"+txtNivel.getText().trim()+";i++) {\n");
        sm.append("\t\tpid = fork();\n");
        int grado = new Integer(txtGrado.getText().trim());
        for(int g=0;g<grado;g++) {
            if ( g == (grado-1) ) { sm.append(Util.repeatChar('\t',g+2)+"if ( pid > 0 ) break;\n");break; }
            else {
                sm.append(Util.repeatChar('\t',g+2)+"if ( pid > 0 ) {\n");
                sm.append(Util.repeatChar('\t',g+3)+"pid = fork();\n");
                lst.add(Util.repeatChar('\t',g+2)+"}\n");
            }
        }
        // cierro if's abiertos
        for(int i=lst.size()-1;i>=0;i--) sm.append(lst.get(i));
        sm.append("\t}\n"); // cierro for
        if ( stipo.equals(tipo[0]) ) { // while(1);
            sm.append("\tprintf(\"pid=%d ppid=%d\\n\",getpid(),getppid());\n");
            sm.append("\t"+tipo[0]+"\n");
        } else  { // wait(0), exec() no tiene sentido en este caso
            sm.append("\tif ( pid > 0 ) {\n\t\tfor(i=0;i<"+grado+";i++) {\n\t\t\tpid_t pidh = wait(0);\n");
            sm.append("\t\t\tprintf(\"proceso pid=%d hijo de ppid=%d finalizado!\\n\",pidh,getpid());\n");
            sm.append("\t\t}\n");
            sm.append("\t}\n");
        } 
        // reemplazo el codigo de este proceso en el buffer principal
        int idx = sb.indexOf("@main");
        sb.replace(idx,idx+5,sm.toString());
        code.setText(sb.toString());        
    }
    /*********************************************************************************************************************
     * code generation case 4
     *********************************************************************************************************************/
    private void doCaso4() {
        StringBuffer sb = new StringBuffer(Proceso.getHeaderProgram());
        String caso = lst.getSelectedValue();
        String stipo = tipo[cmbTipo.getSelectedIndex()];
        StringBuffer sm = new StringBuffer(); // buffer de generacion de codigo temporario
        sm.append("\tint i;\n\tpid = fork();\n");
        int np = new Integer(txtHijos.getText().trim());
        np--;
        if ( stipo.equals(tipo[0]) ) { // while(1);
            sm.append("\tfor(i=0;i<"+np+";i++) {\n");
            sm.append("\t\tif ( pid == 0) pid = fork();\n\t\telse break;\n");
            sm.append("\t}\n");
            sm.append("\tprintf(\"pid=%d ppid=%d\\n\",getpid(),getppid());\n");
            sm.append("\t"+tipo[0]+"\n");
        } else if ( stipo.equals(tipo[1]) ) { // wait(0)
            sm.append("\tif ( pid > 0 ) wait(0);\n");
            sm.append("\tfor(i=0;i<"+np+";i++) {\n");
            sm.append("\t\tif ( pid == 0) pid = fork();\n\t\telse wait(0);\n");
            sm.append("\t}\n");
            sm.append("\tif ( pid > 0 ) wait(0);\n");
            sm.append("\tprintf(\"pid=%d ppid=%d\\n\",getpid(),getppid());\n");
        } else { // exec()
            sm.append("\tfor(i=0;i<"+np+";i++) {\n");
            String cmd = "\""+txtExec.getText().trim()+"\"";
            sm.append("\t\tif ( pid == 0 ) execlp("+cmd+","+cmd+",0);\n\t\telse break;\n");
            sm.append("\t}\n");
            sm.append("\tprintf(\"pid=%d ppid=%d\\n\",getpid(),getppid());\n");
        }
        // reemplazo el codigo de este proceso en el buffer principal
        int idx = sb.indexOf("@main");
        sb.replace(idx,idx+5,sm.toString());
        code.setText(sb.toString());
    }
    
    
    public static void main(String arg[]) {
        SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                new Main();
            }
        });
    }
}
