import java.util.*;
/**
 * Reprentacion de un proceso
 *
 * @author G. Cherencio
 * @version 1.0
 */
public class Proceso {
    private String nombre = null;
    private List<String> code = new ArrayList<String>();
    public Proceso() {
        this("main");
    }
    public Proceso(String n) {
        setNombre(n);
        setDefaultCode();
    }
    // setter
    public void setNombre(String s) { nombre = s; }
    public void setCode(String s) {
        String lines[] = s.split("\n");
        code.clear();
        for(String l : lines) code.add(l);
    }
    
    // getter
    public static String getHeaderProgram() {
        StringBuffer sb = new StringBuffer("#include <stdio.h>\n#include <stdlib.h>\n#include <sys/types.h>\n#include <sys/wait.h>\n#include <unistd.h>\nextern char **environ;\n");
        sb.append("int main(int argc, char **argv) {\n\tpid_t pid;\n@main\n\treturn 0;\n}\n");
        return sb.toString();
    }
    public String getNombre() { return nombre; }
    public String getCode() {
        return getCode(""); 
    }
    public String getCode(String tabs) {
        StringBuffer sb = new StringBuffer();
        for(String l : code) {
            sb.append(tabs+l+"\n");
        }
        return sb.toString(); 
    }
    // custom
    private void setDefaultCode() {
        code.add("printf(\"proceso ["+getNombre()+"] pid=%d ppid=%d\\n\",getpid(),getppid());");
        //code.add("while(1);");
    }
    // object
    @Override
    public String toString() {
        return getNombre();
    }
    @Override
    public int hashCode() { return getNombre().hashCode(); }
    @Override
    public boolean equals(Object obj) {
        Proceso p = (Proceso) obj;
        return getNombre().equals(p.getNombre());
    }
}
